`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Quenne Electric
// Engineer: Andras Bognar
// 
// Create Date:    14:44:54 07/01/2007 
// Design Name: 
// Module Name:    robot_top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: Serial robot interface
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module robot_top(CLK, DATA, STROBE, OUT, _ST_SH, _DATA, _COUNTER);
	 input CLK;				//DATA must be hold until min. 2 CLK time
    input [7:0] DATA;
    input STROBE;
    output OUT;
	 //test
	 output [1:0] _ST_SH;
	 output [7:0] _DATA;
	 output [7:0] _COUNTER;

	reg [7:0] counter=8'h0;
	reg [7:0] data=8'h0;
	reg [1:0] st_sh=8'h0;	//strobe shift
	reg out=0;
	
	always@(posedge CLK)
		begin
		counter<=counter+1;
		if(counter==8'h0)out<=1;
		else if(counter==data)out=0;
		st_sh[1]<=st_sh[0];
		st_sh[0]<=STROBE;
		if(st_sh==2'b01)data<=DATA;
		end
		
	assign OUT=out; 
	//test
	assign _ST_SH=st_sh;
	assign _DATA=data;
	assign _COUNTER=counter;

endmodule
